import { ServiceProvider } from '../ServiceProvider';
export declare class Describer {
    static describe(val: any, found?: Record<string, boolean>): string[];
}
export declare const ProviderMock: {
    /**
     * Turns provider into a mock-fixture
     * when directly asked to provide it will provide a proper instance
     * Anything the proper instance depend on will be mocked, but still provided
     * Note this will still respect lifetimes (i.e. if a singleton is requested multiple times it will be the same instance)
     * Any function called on dependencies will by default throw an error which you need to override with something like jest.spyOn(..).returns(..)
     * Any other property will be defaulted to undefined
     * Note this is not true for dynamic functions and properties which gets set or changed outside of the dependency injection
     */
    mock: <E>(provider: ServiceProvider<E>, setup?: { [key in keyof E]: (mockedValue: Required<E>[key], provider: ServiceProvider<E>) => void; } | undefined) => ServiceProvider<E>;
};
